"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.computeProps = void 0;
const generate_default_props_1 = require("./generators/generate-default-props");
const generate_invocation_1 = require("./generators/generate-invocation");
const generate_type_declarations_1 = require("./generators/generate-type-declarations");
async function computeProps({ component, }) {
    const result = await component.analyze();
    const typeDeclarationsSource = (0, generate_type_declarations_1.generateTypeDeclarations)(component.name, result.propsType, result.providedArgs, result.types);
    const { source: defaultPropsSource, propKeys: defaultPropsKeys } = (0, generate_default_props_1.generateDefaultProps)(result.propsType, result.types);
    const defaultInvocationSource = (0, generate_invocation_1.generateInvocation)(result.propsType, new Set([...defaultPropsKeys, ...result.providedArgs]), result.types);
    return {
        typeDeclarationsSource,
        defaultPropsSource,
        defaultInvocationSource,
    };
}
exports.computeProps = computeProps;
