import { CollectedTypes, ValueType } from "@previewjs/type-analyzer";
/**
 * Generates props that will be set on a component even if no props are specified.
 *
 * In particular, this is useful for callbacks like `onClick` which don't need to be set explicitly.
 */
export declare function generateDefaultProps(propsType: ValueType, types: CollectedTypes): {
    source: string;
    propKeys: Set<string>;
};
