import { localEndpoints, PersistedState } from "@previewjs/api";
import { RequestHandlerForEndpoint } from "./router";
export interface PersistedStateManager {
    get: RequestHandlerForEndpoint<typeof localEndpoints.GetState>;
    update: RequestHandlerForEndpoint<typeof localEndpoints.UpdateState>;
}
export declare class LocalFilePersistedStateManager implements PersistedStateManager {
    #private;
    private readonly absoluteFilePath;
    constructor(absoluteFilePath?: string);
    get: () => Promise<PersistedState>;
    update: (partialState: Partial<PersistedState>) => Promise<PersistedState>;
}
