"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _LocalFilePersistedStateManager_instances, _LocalFilePersistedStateManager_read, _LocalFilePersistedStateManager_update;
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalFilePersistedStateManager = void 0;
const env_paths_1 = __importDefault(require("env-paths"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
class LocalFilePersistedStateManager {
    constructor(absoluteFilePath = path_1.default.join((0, env_paths_1.default)("previewjs").config, "state.json")) {
        this.absoluteFilePath = absoluteFilePath;
        _LocalFilePersistedStateManager_instances.add(this);
        this.get = async () => {
            const state = await __classPrivateFieldGet(this, _LocalFilePersistedStateManager_instances, "m", _LocalFilePersistedStateManager_read).call(this);
            return state || __classPrivateFieldGet(this, _LocalFilePersistedStateManager_instances, "m", _LocalFilePersistedStateManager_update).call(this, {});
        };
        this.update = async (partialState) => {
            return __classPrivateFieldGet(this, _LocalFilePersistedStateManager_instances, "m", _LocalFilePersistedStateManager_update).call(this, partialState);
        };
    }
}
exports.LocalFilePersistedStateManager = LocalFilePersistedStateManager;
_LocalFilePersistedStateManager_instances = new WeakSet(), _LocalFilePersistedStateManager_read = async function _LocalFilePersistedStateManager_read() {
    try {
        const content = await fs_extra_1.default.readFile(this.absoluteFilePath, "utf8");
        return JSON.parse(content);
    }
    catch {
        return null;
    }
}, _LocalFilePersistedStateManager_update = async function _LocalFilePersistedStateManager_update(partialState) {
    const state = {
        ...(await (__classPrivateFieldGet(this, _LocalFilePersistedStateManager_instances, "m", _LocalFilePersistedStateManager_read).call(this) || {})),
        ...partialState,
    };
    await fs_extra_1.default.ensureDir(path_1.default.dirname(this.absoluteFilePath));
    await fs_extra_1.default.writeFile(this.absoluteFilePath, JSON.stringify(state, null, 2), "utf8");
    return state;
};
