import { RequestHandler } from "express";
import { FrameworkPlugin, FrameworkPluginFactory, PersistedStateManager, Workspace } from ".";
import { ApiRouter } from "./router";
export declare type SetupPreviewEnvironment = (options: {
    rootDirPath: string;
}) => Promise<PreviewEnvironment>;
export declare type PreviewEnvironment = {
    middlewares?: RequestHandler[];
    persistedStateManager?: PersistedStateManager;
    onReady?(options: {
        router: ApiRouter;
        workspace: Workspace;
    }): Promise<void>;
};
export declare function loadPreviewEnv({ rootDirPath, setupEnvironment, frameworkPluginFactories, }: {
    rootDirPath: string;
    setupEnvironment: SetupPreviewEnvironment;
    frameworkPluginFactories?: FrameworkPluginFactory[];
}): Promise<{
    previewEnv: PreviewEnvironment;
    frameworkPlugin: FrameworkPlugin;
} | null>;
