import { Reader } from "@previewjs/vfs";
import express from "express";
import * as vite from "vite";
import { FrameworkPlugin } from "./plugins/framework";
export declare class Previewer {
    private readonly options;
    private readonly transformingReader;
    private appServer;
    private viteManager;
    private status;
    private shutdownCheckInterval;
    private disposeObserver;
    private config;
    constructor(options: {
        reader: Reader;
        previewDirPath: string;
        rootDirPath: string;
        logLevel: vite.UserConfig["logLevel"];
        frameworkPlugin: FrameworkPlugin;
        middlewares: express.RequestHandler[];
        onFileChanged?(absoluteFilePath: string): void;
    });
    start(allocatePort: () => Promise<number>): Promise<number>;
    private startFromStopped;
    stop(options?: {
        onceUnused?: boolean;
    }): Promise<void>;
    private configWithWrapper;
    private shutdownCheck;
    private stopNow;
    private readonly onFileChangeListener;
}
