import { Endpoint, RequestOf, ResponseOf, WrappedResponse } from "@previewjs/api";
import { Request as ExpressRequest, Response as ExpressResponse } from "express";
export declare class ApiRouter {
    private handlers;
    handle(path: string, request: unknown, expressRequest: ExpressRequest, expressResponse: ExpressResponse): Promise<WrappedResponse<unknown>>;
    onRequest<E extends Endpoint<any, any>>(endpoint: E, handler: RequestHandler<RequestOf<E>, ResponseOf<E>>): void;
}
export declare type RequestHandlerForEndpoint<E> = E extends Endpoint<infer Request, infer Response> ? RequestHandler<Request, Response> : never;
export declare type RequestHandler<Request, Response> = (request: Request, expressRequest: ExpressRequest, expressResponse: ExpressResponse) => Promise<Response>;
